package sun.print;

import java.awt.Graphics2D;
import java.awt.print.PageFormat;
import java.awt.Graphics;
import java.net.URL;
import javax.imageio.ImageIO;
import java.io.InputStream;
import java.awt.image.BufferedImage;
import java.awt.print.Printable;

class ImagePrinter implements Printable
{
    BufferedImage image;
    
    ImagePrinter(InputStream input) {
        try {
            this.image = ImageIO.read(input);
        }
        catch (Exception ex) {}
    }
    
    ImagePrinter(URL input) {
        try {
            this.image = ImageIO.read(input);
        }
        catch (Exception ex) {}
    }
    
    @Override
    public int print(Graphics graphics, PageFormat pageFormat, int n) {
        if (n > 0 || this.image == null) {
            return 1;
        }
        ((Graphics2D)graphics).translate(pageFormat.getImageableX(), pageFormat.getImageableY());
        int width = this.image.getWidth(null);
        int height = this.image.getHeight(null);
        int n2 = (int)pageFormat.getImageableWidth();
        int n3 = (int)pageFormat.getImageableHeight();
        int n4 = width;
        n3 = height;
        if (n4 > n2) {
            n3 = (int)((float)n3 * ((float)n2 / (float)n4));
            n4 = n2;
        }
        if (n3 > n3) {
            n4 = (int)((float)n4 * ((float)n3 / (float)n3));
        }
        int n5 = (n2 - n4) / 2;
        int n6 = (n3 - n3) / 2;
        graphics.drawImage(this.image, n5, n6, n5 + n4, n6 + n3, 0, 0, width, height, null);
        return 0;
    }
}
